# Copyright 2018 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#
# Refer to the README and COPYING files for full details of the license
import ConfigParser

_LABELER_CONFIG_FILE = '/etc/ovirt-lldp-labeler/conf.d/ovirt-lldp-labeler.conf'
_CREDENTIALS_CONFIG_FILE = '/etc/ovirt-lldp-labeler/conf.d/ovirt-lldp-credentials.conf'

_CREDENTIALS_SECTION = 'credentials'
_LABELER_SECTION = 'labeler'

_CLUSTER_CONFIG = 'clusters'
_API_URL_CONFIG = 'api_url'
_CA_FILE_CONFIG = 'ca_file'

_API_USERNAME = 'username'
_API_PASSWORD = 'password'

_COMMA_SEPARATOR = ','


_config = ConfigParser.ConfigParser()
_config.read(_LABELER_CONFIG_FILE)
_config.read(_CREDENTIALS_CONFIG_FILE)


def get_clusters_from_config():
    return _split_by_separator(_config.get(_LABELER_SECTION, _CLUSTER_CONFIG), _COMMA_SEPARATOR)


def get_api_url():
    return _config.get(_LABELER_SECTION, _API_URL_CONFIG)


def get_api_username():
    return _config.get(_CREDENTIALS_SECTION, _API_USERNAME)


def get_api_password():
    return _config.get(_CREDENTIALS_SECTION, _API_PASSWORD)


def get_ca_file():
    return _config.get(_LABELER_SECTION, _CA_FILE_CONFIG)


def _split_by_separator(value, separator):
    splited = value.split(separator)
    return [val.strip() for val in splited]
